unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    btnEdit: TButton;
    Button3: TButton;
    Button4: TButton;
    eLabelmaxwidth: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    rgLayout: TRadioGroup;
    ScrollBox1: TScrollBox;
    procedure Button1Click(Sender: TObject);
    procedure eLabelmaxwidthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FiTop:integer;
    iSpacer:integer;
    iLeft:integer;
    iLeftLabel:integer;
    iLabelmaxwidth:integer;

    //formats Control and returns calculated next top posiition
    function FormatControls(oLbl:TLabel;oCtrl:TControl; iVerticalSpace:integer):integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  oLabel:TLabel;
  oEdit:TEdit;
  oBttn:TButton;
begin
  if sender = Button1 then
    begin
      With TLabel.Create(self) do
      begin
        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Top:=FiTop;
        left:=iLeftLabel;
        width := iLabelmaxwidth;
      end;

      with TButton.Create(self) do
      begin
        Caption :='Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Top:=FiTop;
        FiTop:= FiTop+height+iSpacer;
        left:=iLeft;
      end;

    end
  else
  if sender = btnEdit then
    begin
      oLabel:= TLabel.Create(self);
      with oLabel do
      begin
        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
        AutoSize := False;
        Parent := ScrollBox1;
        Top:=FiTop;
        left:=iLeftLabel;
        width := iLabelmaxwidth ;
      end;

      oEdit:= TEdit.Create(self);
      with oEdit do
      begin
        Text := 'Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Top:=FiTop;
        //FiTop:= FiTop+height+iSpacer;
        left:=iLeft;
      end;

      FiTop:=FormatControls(oLabel,oEdit,iSpacer);

    end
  else
  if sender = Button3 then
    begin
      With TLabel.Create(self) do
      begin
        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Top:=FiTop;
        left:=iLeftLabel;
        width := iLabelmaxwidth;
      end;

      with TCheckbox.Create(self) do
      begin
        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Top:=FiTop;
        FiTop:= FiTop+height+iSpacer;
        left:=iLeft;

        //align:=  alTop;
      end;
    end
  else
  if sender = Button4 then
    begin
      //With TLabel.Create(self) do
      //begin
      //  caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
      //  Parent := ScrollBox1;
      //  Top:=FiTop;
      //  left:=iLeftLabel;
      //  width := iLabelmaxwidth;
      //end;

      with TRadioGroup.Create(self) do
      begin
        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
        Parent := ScrollBox1;
        Items.Add('eins');
        Items.Add('zwei');
        Items.Add('drei');
        columns:=3;
        height:=40;
        Top:=FiTop;
        FiTop:= FiTop+height+iSpacer;
        left:=iLeft;

        //align:=  alTop;
      end;
    end
  else
    raise Exception.Create('Not supported.');


  Caption := IntToStr(ScrollBox1.ControlCount) + ' controls in ScrollBox';
end;

//procedure TForm1.Button1Click(Sender: TObject);
//var
//  oLabel:TLabel;
//  oEdit:TEdit;
//begin
//  if sender = Button1 then
//    begin
//      With TLabel.Create(self) do
//      begin
//        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        left:=iLeftLabel;
//        width := iLabelmaxwidth;
//      end;
//
//      with TButton.Create(self) do
//      begin
//        Caption :='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        FiTop:= FiTop+height+iSpacer;
//        left:=iLeft;
//        //align:=  alTop;
//      end;
//
//    end
//  else
//  if sender = btnEdit then
//    begin
//      oLabel:= TLabel.Create(self);
//      with oLabel do
//      begin
//        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        left:=iLeftLabel;
//        width := iLabelmaxwidth;
//      end;
//
//
//      oEdit:= TEdit.Create(self);
//      with oEdit do
//      begin
//        Text := 'Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        FiTop:= FiTop+height+iSpacer;
//        left:=iLeft;
//
//        //align:=  alTop;
//      end;
//      //With TLabel.Create(self) do
//      //begin
//      //  caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//      //  Parent := ScrollBox1;
//      //  Top:=FiTop;
//      //  left:=iLeftLabel;
//      //  width := iLabelmaxwidth;
//      //end;
//      //
//      //with TEdit.Create(self) do
//      //begin
//      //  Text := 'Control #' + IntToStr(ScrollBox1.ControlCount);
//      //  Parent := ScrollBox1;
//      //  Top:=FiTop;
//      //  FiTop:= FiTop+height+iSpacer;
//      //  left:=iLeft;
//      //
//      //  //align:=  alTop;
//      //end;
//    end
//  else
//  if sender = Button3 then
//    begin
//      With TLabel.Create(self) do
//      begin
//        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        left:=iLeftLabel;
//        width := iLabelmaxwidth;
//      end;
//
//      with TCheckbox.Create(self) do
//      begin
//        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Top:=FiTop;
//        FiTop:= FiTop+height+iSpacer;
//        left:=iLeft;
//
//        //align:=  alTop;
//      end;
//    end
//  else
//  if sender = Button4 then
//    begin
//      //With TLabel.Create(self) do
//      //begin
//      //  caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//      //  Parent := ScrollBox1;
//      //  Top:=FiTop;
//      //  left:=iLeftLabel;
//      //  width := iLabelmaxwidth;
//      //end;
//
//      with TRadioGroup.Create(self) do
//      begin
//        caption:='Control #' + IntToStr(ScrollBox1.ControlCount);
//        Parent := ScrollBox1;
//        Items.Add('eins');
//        Items.Add('zwei');
//        Items.Add('drei');
//        columns:=3;
//        height:=40;
//        Top:=FiTop;
//        FiTop:= FiTop+height+iSpacer;
//        left:=iLeft;
//
//        //align:=  alTop;
//      end;
//    end
//  else
//    raise Exception.Create('Not supported.');
//
//
//  Caption := IntToStr(ScrollBox1.ControlCount) + ' controls in ScrollBox';
//end;

procedure TForm1.eLabelmaxwidthChange(Sender: TObject);
begin
  iLabelmaxwidth:= strtoint(eLabelmaxwidth.text);
  iLeft:=iLeftLabel + iLabelmaxwidth +3 ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FiTop:=6;
  iSpacer:=5;

  iLeftLabel:=5;
  iLabelmaxwidth:=80;

  iLeft:=iLeftLabel + iLabelmaxwidth +3 ;
  eLabelmaxwidth.Text:=inttostr( iLabelmaxwidth);
  rgLayout.ItemIndex:=0;
  btnEdit.Default:=true;
end;

function TForm1.FormatControls(oLbl: TLabel; oCtrl: TControl;
  iVerticalSpace: integer): integer;
begin
case rgLayout.Itemindex of
  0: begin
    //Label left, edit with width
    //+--------+ +-------+
    //| Label1 | | Edit1 |
    //+--------+ |       |
    //           +-------+
    oLbl.AnchorSideLeft.Control := ScrollBox1;
    oLbl.BorderSpacing.Left := iLeftLabel;
    oLbl.Anchors := [akLeft];

    oCtrl.AnchorSideLeft.Control := oLbl;
    oCtrl.AnchorSideLeft.Side := asrBottom;
    oCtrl.Anchors := [akLeft];
    oCtrl.BorderSpacing.Left := 6;

    end;
  1: begin
    //Label left, edit fullsize
    //+--------+ +----------------------------------+
    //| Label1 | | Edit1                            |
    //+--------+ |                                  |
    //           +----------------------------------+
    oLbl.AnchorSideLeft.Control := ScrollBox1;
    oLbl.BorderSpacing.Left := iLeftLabel;
    oLbl.Anchors := [akLeft];

    oCtrl.AnchorSideLeft.Control := oLbl;
    oCtrl.AnchorSideLeft.Side := asrBottom;
    oCtrl.AnchorSideRight.Control := ScrollBox1;
    oCtrl.AnchorSideRight.Side := asrBottom;
    oCtrl.Anchors := [akLeft, akRight];
    oCtrl.BorderSpacing.Left := 6;
    oCtrl.BorderSpacing.Right := 25;
    end;
  2: begin
    //Label top, edit per width
    //+--------+
    //| Label1 |
    //+--------+
    //+-------------+
    //| Edit1       |
    //|             |
    //+-------------+

    oLbl.AnchorSideLeft.Control := ScrollBox1;
    oLbl.BorderSpacing.Left := iLeftLabel;
    oLbl.Anchors := [akLeft];

    oCtrl.Top:=oLbl.Top + oLbl.Height;
    oCtrl.AnchorSideLeft.Control := ScrollBox1;
    //oCtrl.AnchorSideLeft.Side := asrBottom;
    //oCtrl.AnchorSideRight.Control := ScrollBox1;
    //oCtrl.AnchorSideRight.Side := asrBottom;

    oCtrl.Anchors := [akLeft];
    oCtrl.BorderSpacing.Left := 6;
    //oCtrl.BorderSpacing.Right := 25;

    //Calculate next Top Position
    //FiTop:= oCtrl.Top+ oCtrl.Height+iSpacer;

    end;
  3: begin
    //Label top, edit fullsize
    //+--------+
    //| Label1 |
    //+--------+
    //+----------------------------------+
    //| Edit1                            |
    //|                                  |
    //+----------------------------------+

    oLbl.AnchorSideLeft.Control := ScrollBox1;
    oLbl.BorderSpacing.Left := iLeftLabel;
    oLbl.Anchors := [akLeft];

    oCtrl.Top:=oLbl.Top + oLbl.Height;
    oCtrl.AnchorSideLeft.Control := ScrollBox1;
    oCtrl.BorderSpacing.Left := 6;
    //oCtrl.AnchorSideLeft.Side := asrBottom;

    oCtrl.AnchorSideRight.Control := ScrollBox1;
    oCtrl.AnchorSideRight.Side := asrBottom;
    oCtrl.Anchors := [akLeft, akRight];

    oCtrl.BorderSpacing.Right := 25;

    //Calculate next Top Position
    //FiTop:= oCtrl.Top+ oCtrl.Height+iSpacer;
    end
end;  //case

//Calculate next Top Position
result:= oCtrl.Top + oCtrl.Height + iVerticalSpace;
end;

end.

